// Well folks, I'm well aware this isn't the greatest of DirectX examples, but I hope it gets the message through
// Comments/Questions - LavaMan842@aol.com

// sorry about the lack of comments in effects.cpp =(

// make sure you do a Relesae build. my VC++ 5 pro didn't like the debug build.. wonder why..


// Remember...link ddraw.lib to your project

#define NAME "Fire Test"
#define TITLE "Fire Test"

#define WIN32_LEAN_AND_MEAN

#include <windows.h>   // include some windows stuff
#include <windowsx.h> // ect..ect
#include <winuser.h>    // might need these later =)
#include <ddraw.h>      // Important - this is your directdraw header file

#include "effects.cpp"   // our file with the fire routines in it


LPDIRECTDRAW lpDD;                           // your directdraw object
LPDIRECTDRAWSURFACE lpDDSPrimary;	         // your primary surface thingy
LPDIRECTDRAWSURFACE lpDDSBack;               // your back surface
//LPDIRECTDRAWSURFACE lpDDSOffScreen;          // an offscreen surface
LPDIRECTDRAWPALETTE lpDDPal;                 // the palette object
PALETTEENTRY	mypal[256];                  // stores palette stuff                                     
BOOL bActive;                                // thingy that tells if your app is active

unsigned char *double_buffer = NULL;
unsigned char *fire_buffer = NULL;

extern int ytab[640];
extern int ftab[1257];


int index = 0;

HRESULT ddrval;


HRESULT restoreAll( void )
{
	HRESULT ddrval;
	
	ddrval = lpDDSPrimary->Restore();
	if(ddrval == DD_OK)
	{

	}
	return ddrval;
} // restore all


static void finiObjects( void )
{
	if( lpDD!=NULL)    // is our DD object null? Meaning nothings there
	{
		if(lpDDSPrimary != NULL)       // is anything on the primary surface
		{ 
			lpDDSPrimary->Release();   // if so..release the info
			lpDDSPrimary = NULL;       // and set the surface to null
		}
		if(lpDDPal != NULL)           // dump the palette too!
		{
			lpDDPal->Release();
			lpDDPal = NULL;
		}
		lpDD->Release();              // bye bye direct draw object
		lpDD = NULL;                  // NULL and VOID
	}
} // finiObjects



long FAR PASCAL WindowProc(HWND hWnd, UINT message, WPARAM wParam,
						   LPARAM lParam)
{
	switch(message)
	{
	case WM_ACTIVATEAPP:
	bActive = wParam;    // important. This tells our app it's either         
	//active or not
		break;

	case WM_SETCURSOR:
		SetCursor(NULL);
		return TRUE;

	case WM_CREATE:
		break;

	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_ESCAPE:
		case VK_F12:
			free(fire_buffer);
			//free(double_buffer);
			PostMessage(hWnd, WM_DESTROY, 0, 0);
			break;
		}
	break;
	case WM_DESTROY:
		finiObjects();
		PostQuitMessage(0);
		break;
	}

return DefWindowProc(hWnd, message, wParam, lParam);  // return
                          //any unused messages - I guess =)

} // window proc

BOOL initFail( HWND hwnd)
{
	finiObjects();
	MessageBox(hwnd, "Direct Draw Init FAILED", TITLE, MB_OK);
	DestroyWindow(hwnd);
	return FALSE;
} // initFail

static BOOL doInit(HINSTANCE hInstance, int nCmdShow)
{
	HWND hwnd;    // our hwnd
	WNDCLASS wc;
	DDSURFACEDESC ddsd;    // holdslike the discription of the surface
	DDSCAPS ddscaps;               // holds the capabilites of the surface
	HRESULT ddrval;


	// SET UP THE WINDOW
	wc.style = CS_HREDRAW|CS_VREDRAW;
	wc.lpfnWndProc = WindowProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(hInstance, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = GetStockBrush(BLACK_BRUSH);
	wc.lpszMenuName = NAME;
	wc.lpszClassName = NAME;
	RegisterClass(&wc); // REGISTER IT

	// now create it
	hwnd = CreateWindowEx( 0, NAME, TITLE, WS_POPUP, 0, 0,  GetSystemMetrics(SM_CXSCREEN),
		GetSystemMetrics(SM_CYSCREEN), NULL, NULL, hInstance, NULL);

	if(!hwnd)
	{
		return FALSE; // window did not create correctly for some reason
	}

	ShowWindow(hwnd, nCmdShow);   
	UpdateWindow(hwnd);


	// NOW WE CREATE THE DDraw stuff
	
	// CREATE DIRECT DRAW SURFACE 
	ddrval = DirectDrawCreate( NULL, &lpDD, NULL);
	if (ddrval != DD_OK)
	{
		return initFail(hwnd);    // failed to create lpDD ( our ddraw object )
	}

	ddrval = lpDD->SetCooperativeLevel(hwnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN);
	if(ddrval != DD_OK)
	{
	return initFail(hwnd); // failed again
	}

	//set the viedo mode
	ddrval = lpDD->SetDisplayMode(640, 480, 8);     // 640x480x8bit

	if(ddrval != DD_OK)
	{
		return initFail(hwnd);    // failed again
	}

	// create the primary surface with 1 back buffer
	ddsd.dwSize = sizeof(ddsd);                   // set the size
	ddsd.dwFlags =  DDSD_CAPS|DDSD_BACKBUFFERCOUNT;   
	// I don't exactly remember what this means. But I know BACKBUFFERCOUNT
	// means that the surface can have a back surface 
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
		DDSCAPS_FLIP|DDSCAPS_COMPLEX;
	// this indicates ( in order ) that the surface being created is a primary surface, it 
	//will be used in page flipping, and that it will have another surface attached to it
	ddsd.dwBackBufferCount = 1;     // now many back surfaces there are attached
	ddrval = lpDD->CreateSurface(&ddsd, &lpDDSPrimary, NULL);   // now create
  	// the surface using ddsd ( the structure we just put the info into )
	if(ddrval != DD_OK)
	{
		return initFail(hwnd);   // it failed to create
	}

	// Now let's set up the back surface
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;   // says it's a back surface
	ddrval = lpDDSPrimary->GetAttachedSurface(&ddscaps, &lpDDSBack); 
	// now attach it to the primary surface
	if(ddrval != DD_OK)
	{
		return initFail(hwnd);  // failed to create 
	}


index = 0;

for (index=95;index<200;index++)
    {
    mypal[index].peRed   = index+70;
	mypal[index].peGreen = index+30;
	mypal[index].peBlue  = rand()%10;
	}
for (index = 1; index < 35; index++)
{
    mypal[index].peRed   = index+25;
	mypal[index].peGreen = rand()%10;
	mypal[index].peBlue  = rand()%10;
}
for (index = 35; index < 55; index++)
{
    mypal[index].peRed   = index+25;
	mypal[index].peGreen = index-25;
	mypal[index].peBlue  = rand()%10;
}
for (index = 55; index < 95; index++)
{
	mypal[index].peRed = index+75;
	mypal[index].peGreen = index;
	mypal[index].peBlue = rand()%5;
}
for(index = 200; index < 255; index++)
{
	mypal[index].peRed = index;
	mypal[index].peGreen = index-rand()%25;
	mypal[index].peBlue = rand()%5;
}


/*
for (index=65;index<235;index++)
	{
    mypal[index].peRed   = index;
	mypal[index].peGreen = 30;
	mypal[index].peBlue  = 10;
}
for(index=235; index<255;index++)
{
    mypal[index].peRed   = 0;
	mypal[index].peGreen = 0;
	mypal[index].peBlue  = 0;
} */
	

	
	lpDD->CreatePalette(DDPCAPS_8BIT | DDPCAPS_ALLOW256, mypal, &lpDDPal, NULL);
	lpDDSPrimary->SetPalette(lpDDPal);


	mk_ytab();
	mk_ftab();   // make our lookup tables

	//double_buffer = (unsigned char *)malloc(307200);
	fire_buffer = (unsigned char *)malloc(307200);
 

	return TRUE;
} // doInit

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, 
				   LPSTR lpCmdLine, int nCmdShow)
{
// any windows programmer should be familiar with this

	MSG msg;

	lpCmdLine = lpCmdLine;
	hPrevInstance = hPrevInstance;
	if(!doInit(hInstance, nCmdShow))
	{
		return FALSE;
	}

	while (1)
	{
		if(PeekMessage(&msg, NULL, 0,0,PM_NOREMOVE))
		{
			if(!GetMessage(&msg, NULL,0,0))
				return msg.wParam;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else if(bActive)
		{


		fire(480, 0, 600, 50);

		// draw fire on bottom row and then flip



		while(1)
		{		
		ddrval = lpDDSPrimary->Flip(NULL, DDFLIP_WAIT);
		if(ddrval == DD_OK)
		{
		break;
		}
		if(ddrval == DDERR_SURFACELOST)
		{
		if(ddrval != DD_OK)
		{
		break;
		}
		}
		if(ddrval != DDERR_WASSTILLDRAWING)
		{
		break;
		} 
		} 
		}  // if bActive
		else
		{//make sure we go to sleep if have nothiing to do
			WaitMessage();
		}
	}
	
} // win main 
